package Hashlocker::HLClone;
use Baseobject;
use FileHandle;
use strict;
use Fcntl;
use Clone;


our @ISA =('Baseobject' );

sub new
{
  my $pkg=shift;
  my $self= bless (new Baseobject(@_),$pkg);

  return $self;
}


sub genread
{
  my $self=shift;
  my $dbname=shift;
  my $text;
  my $clone;

  local $/=undef;
  my $filehandle= new FileHandle();

  open ($filehandle,$dbname) or do
  {
    $self->error("Could not open file for reading: $dbname, $!");
    return undef;
  };

  $text=<$filehandle>;

  $clone=Clone::fromtext($text);
  unless (defined ($clone))
  {
    $self->error("Could not Clone::fromtext for $dbname, file might be corrupt or wrongly initialised\nConsider removing it:\nrm $dbname\n") ;
    return undef;
  }

  $clone;
}

sub read
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;
  my $text;
  $dbname.='.Clone';
  my $clone=$self->genread($dbname);

  return $func->($clone,@_) if (defined($clone));
  return undef;
}

sub write
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;
  my $hl=shift;
  my $result;
  my $clone={};
  my $filehandle= new FileHandle();

  $dbname.='.Clone';
  if (-e $dbname)
  {
    $clone=$self->genread($dbname);
    return undef unless (defined( $clone));
  }

  $result= $func->($clone,@_) ;

  my $mask=umask;
  umask $hl->field('umask');

  unless (sysopen ($filehandle,$dbname,O_WRONLY|O_CREAT|O_TRUNC,$hl->field('fileperm')))
  {
    umask $mask;
    $self->error("Could open file for writing: $dbname, $!");
    return undef;
  }

  my $text=Clone::copy2text($clone);

  print $filehandle $text;
  close ($filehandle);
  umask $mask;

  $result;
}


# Local Variables:
# mode: perl
# mode: font-lock
# End:
